%Program to create all the results in one go
m=xlsread('intradaily.xlsx','Sheet1','A2:E264');
m(1:176,5)=nan;   %Ten-year changes only count as asset purchase surprises post ZLB
%Now orthogonalize to construct target, guidance and asset purchase shocks
m(177:end,5)=m(177:end,5)-(m(177:end,3:4)*inv(m(177:end,3:4)'*m(177:end,3:4))*m(177:end,3:4)'*m(177:end,5));
m(:,4)=m(:,4)-(m(:,3)*inv(m(:,3)'*m(:,3))*m(:,3)'*m(:,4));
m=[m(:,1)+(m(:,2)/12)-(1/24) m(:,3:5)];
subplot(3,1,1);
bar(m(:,1),m(:,2));
axis([1994 2016 -0.6 0.6]);
title('Target Surprises');
pause(1)
subplot(3,1,2);
bar(m(:,1),m(:,3));
axis([1994 2016 -0.6 0.6]);
title('Forward Guidance Surprises');
pause(1)
subplot(3,1,3);
bar(m(177:end,1),m(177:end,4));
axis([2008 2016 -0.6 0.6]);
title('Asset Purchase Surprises');
pause(1)
print -dpdf fig1
%---------------------------------------%
clear
close all
disp('UK: Target Surprises');
code=0; shock=1; ctry='uk';
myprogbayes
clear
disp('Euro: Target Surprises');
code=0; shock=1; ctry='ge';
myprogbayes
clear
disp('Japan: Target Surprises');
code=0; shock=1; ctry='ja';
myprogbayes
clear
disp('UK: Guidance Surprises');
code=0; shock=2; ctry='uk';
myprogbayes
clear
disp('Euro: Guidance Surprises');
code=0; shock=2; ctry='ge';
myprogbayes
clear
disp('Japan: Guidance Surprises');
code=0; shock=2; ctry='ja';
myprogbayes
clear
disp('UK: Asset Purchase Surprises');
code=0; shock=3; ctry='uk';
myprogbayes
clear
disp('Euro: Asset Purchase Surprises');
code=0; shock=3; ctry='ge';
myprogbayes
clear
disp('Japan: Asset Purchase Surprises');
code=0; shock=3; ctry='ja';
myprogbayes
clear
disp('Domestic Only: Target Surprises');
code=0; shock=1; ctry='none';
myprogbayes;
clear
disp('Domestic Only: Guidance Surprises');
code=0; shock=2; ctry='none';
myprogbayes;
clear
disp('Domestic Only: Asset Purchase Surprises');
code=0; shock=3; ctry='none';
myprogbayes;
clear;
figure(1)
subplot(3,3,1); axis([0 60 -1 2]);
subplot(3,3,2); axis([0 60 -2 4]);
subplot(3,3,3); axis([0 60 -1 2]);
subplot(3,3,4); axis([0 60 -2 2]);
subplot(3,3,5); axis([0 60 -2 5]);
subplot(3,3,6); axis([0 60 -2 3]);
subplot(3,3,7); axis([0 60 -0.5 2]);
subplot(3,3,8); axis([0 60 -2 2]);
subplot(3,3,9); axis([0 60 -1 2]);
print -dpdf fig2
figure(2)
subplot(3,3,1); axis([0 60 -0.4 0.4]);
subplot(3,3,2); axis([0 60 -0.5 0.5]);
subplot(3,3,3); axis([0 60 -0.4 0.4]);
subplot(3,3,4); axis([0 60 -0.3 0.2]);
subplot(3,3,5); axis([0 60 -0.2 0.3]);
subplot(3,3,6); axis([0 60 -0.2 0.2]);
subplot(3,3,7); axis([0 60 -0.3 0.1]);
subplot(3,3,8); axis([0 60 -0.1 0.1]);
subplot(3,3,9); axis([0 60 -0.1 0.1]);
print -dpdf fig3
figure(3)
subplot(3,3,1); axis([0 60 -0.3 0.1]);
subplot(3,3,2); axis([0 60 -0.2 0.2]);
subplot(3,3,3); axis([0 60 -0.3 0]);
subplot(3,3,4); axis([0 60 -0.2 0.2]);
subplot(3,3,5); axis([0 60 -0.2 0.2]);
subplot(3,3,6); axis([0 60 -0.3 0]);
subplot(3,3,7); axis([0 60 -0.2 0.1]);
subplot(3,3,8); axis([0 60 -0.1 0.1]);
subplot(3,3,9); axis([0 60 -0.15 0.05]);
print -dpdf fig4
figure(4)
subplot(3,3,1); axis([0 60 -2 1]);
subplot(3,3,2); axis([0 60 -1 3]);
subplot(3,3,3); axis([0 60 -2 1]);
subplot(3,3,4); axis([0 60 -1 1]);
subplot(3,3,5); axis([0 60 -1 3]);
subplot(3,3,6); axis([0 60 -2 1]);
subplot(3,3,7); axis([0 60 -1 2]);
subplot(3,3,8); axis([0 60 -2 1]);
subplot(3,3,9); axis([0 60 -2 1]);
print -dpdf fig5
figure(5)
subplot(3,3,1); axis([0 60 -0.03 0.04]);
subplot(3,3,2); axis([0 60 -0.08 0.02]);
subplot(3,3,3); axis([0 60 -0.04 0.02]);
subplot(3,3,4); axis([0 60 -0.2 0.6]);
subplot(3,3,5); axis([0 60 -0.4 0.4]);
subplot(3,3,6); axis([0 60 -0.2 0.6]);
subplot(3,3,7); axis([0 60 -0.2 0.2]);
subplot(3,3,8); axis([0 60 -0.4 0.1]);
subplot(3,3,9); axis([0 60 -0.2 0.2]);
print -dpdf fig6



clear
close all
code=0; shock=1; ctry='uk2';
myprogbayes
clear
code=0; shock=1; ctry='ge2';
myprogbayes
clear
code=0; shock=1; ctry='ja2';
myprogbayes
clear
figure(1)
subplot(2,2,1); axis([0 60 -1.5 1]);
subplot(2,2,2); axis([0 60 0 1.7]);
subplot(2,2,3); axis([0 60 -4 4]);
print -dpdf fig7
figure(2)
subplot(3,2,1); axis([0 60 -0.1 0.4]);
subplot(3,2,2); axis([0 60 -0.2 0.3]);
subplot(3,2,3); axis([0 60 -0.1 0.15]);
subplot(3,2,4); axis([0 60 -0.1 0.15]);
subplot(3,2,5); axis([0 60 -0.7 0.3]);
subplot(3,2,6); axis([0 60 -0.5 0.1]);
print -dpdf fig8
figure(3)
subplot(2,2,1); axis([0 60 -2 1.5]);
subplot(2,2,2); axis([0 60 -2.5 0.5]);
subplot(2,2,3); axis([0 60 -2 5]);
print -dpdf fig9

