%Before running this program, the user must specify:
%ctry: uk, ge, ja, uk2, ge2 or ja2 or none for US term premia (uk2, ge2 and ja2 are for foreign MPS)
%shock: 1 for the target funds rate, 2 for forward guidance, 3 for the asset purchase
%code: 0 for no adjustments, 1 for using EU data, 2 for detrending everything, 3 for forward guidance over ZLB alone, 4 for using tight window
%------------------------------%
shockvec={'U.S. Target','U.S. Guidance','U.S. Asset Purchase'};
nlead=20;  %Number of impulse responses to plot
horr=[0:3:3*nlead]'; 
%normind specifies which element of the VAR is hit by a 25 basis point shock
if strcmp(ctry,'uk')==1; if shock==1; normind=1; else; normind=2; end; end;
if strcmp(ctry,'ge')==1; if shock==1; normind=1; else; normind=2; end; end;
if strcmp(ctry,'ja')==1; if shock==1; normind=1; else; normind=2; end; end;
if strcmp(ctry,'none')==1; if shock==1; normind=1; else; normind=2; end; end;
if strcmp(ctry,'ge2')==1; normind=7; end;
if strcmp(ctry,'uk2')==1; normind=2; end;
if strcmp(ctry,'ja2')==1; normind=2; end;
mus=xlsread('monthly.xlsx','us','A223:T534');
muk=xlsread('monthly.xlsx','uk','A2:R313');
mge=xlsread('monthly.xlsx','ge','A2:R205');
meu=xlsread('monthly.xlsx','eu','A2:I205');
mge(:,16:17)=meu(:,8:9);  %Use EU macro data
if code==1; mge(69:end,[5 10 15])=meu(69:end,5:7); end; %Switch for EU yield data
mja=xlsread('monthly.xlsx','ja','A2:Q313');
mit=xlsread('monthly.xlsx','it','A2:G205');
mge=[mge mit(:,5:7)];
dus=datenum(mus(:,3),mus(:,1),eomday(mus(:,3),mus(:,1)));
duk=datenum(muk(:,3),muk(:,1),eomday(muk(:,3),muk(:,1)));
dge=datenum(mge(:,3),mge(:,1),eomday(mge(:,3),mge(:,1)));
dja=datenum(mja(:,3),mja(:,1),eomday(mja(:,3),mja(:,1)));
if strcmp(ctry,'uk')+strcmp(ctry,'ge')+strcmp(ctry,'ja')+strcmp(ctry,'none')==1;
    z0=xlsread('intradaily.xlsx','Sheet1','A2:Q264');
    if code==4; z0(:,3:5)=xlsread('intradaily.xlsx','Sheet5','C2:E264'); end;
    z0(:,4)=z0(:,4)-(z0(:,3)*inv(z0(:,3)'*z0(:,3))*z0(:,3)'*z0(:,4));
    z0(:,5)=z0(:,5)-(z0(:,3:4)*inv(z0(:,3:4)'*z0(:,3:4))*z0(:,3:4)'*z0(:,5));
    if code==1; z0(128:end,13:14)=xlsread('intradaily.xlsx','Sheet1','R129:S264'); end;        
end;
if strcmp(ctry,'uk2')==1;
    z0=xlsread('intradaily.xlsx','Sheet2','A2:I88');
    if code==4; z0(:,3)=xlsread('intradaily.xlsx','Sheet5','I2:I88');  end;
end;
if strcmp(ctry,'ge2')==1;
    z0=xlsread('intradaily.xlsx','Sheet3','A2:J102');
    if code==1; z0(:,4:6)=xlsread('intradaily.xlsx','Sheet3','K2:M102'); end;
    if code==4; z0(:,3)=xlsread('intradaily.xlsx','Sheet5','M2:M102');  end;
end;
if strcmp(ctry,'ja2')==1;
    z0=xlsread('intradaily.xlsx','Sheet4','A2:I193');
    if code==4; z0(:,3)=xlsread('intradaily.xlsx','Sheet5','Q2:Q193');  end;
end;
if strcmp(ctry,'uk')+strcmp(ctry,'ge')+strcmp(ctry,'ja')+strcmp(ctry,'none')==1;
   if shock==1; z0=z0(1:176,:); end;
   if shock==3; z0=z0(177:end,:); end;
   if shock==2 & code==3; z0=z0(177:end,:); end;
end;
%Set up the data: y is the data in the VAR; zindx gives the columns of HF data
if strcmp(ctry,'uk')==1;
    [c,ia,ib]=intersect(dus,duk);
    y=[mus(ia,4) mus(ia,9) mus(ia,14) 100*log(muk(ib,4)) muk(ib,5) muk(ib,15) mus(ia,15) 100*log(mus(ia,18)) mus(ia,19)];
    if code==2; y=detrend(y,'linear'); else; y=[detrend(y(:,1:7),'constant') detrend(y(:,8),'linear') detrend(y(:,9),'constant')]; end;
    zindx=[shock 4 5 6 7 8 9]; 
end;
if strcmp(ctry,'ge')==1;
    [c,ia,ib]=intersect(dus,dge);
    y=[mus(ia,4) mus(ia,9) mus(ia,14) 100*log(mge(ib,4)) mge(ib,5) mge(ib,15) mus(ia,15) 100*log(mus(ia,18)) mus(ia,19)];
    if code==2; y=detrend(y,'linear'); else; y=[detrend(y(:,1:7),'constant') detrend(y(:,8),'linear') detrend(y(:,9),'constant')]; end;
    zindx=[shock 4 5 6 10 11 12];
end;
if strcmp(ctry,'ja')==1;
    [c,ia,ib]=intersect(dus,dja);
    y=[mus(ia,4) mus(ia,9) mus(ia,14) 100*log(mja(ib,4)) mja(ib,5) mja(ib,15) mus(ia,15) 100*log(mus(ia,18)) mus(ia,19)];
    if code==2; y=detrend(y,'linear'); else; y=[detrend(y(:,1:7),'constant') detrend(y(:,8),'linear') detrend(y(:,9),'constant')]; end;
    zindx=[shock 4 5 6 13 14 15]; 
end;
if strcmp(ctry,'uk2')==1;
    [c,ia,ib]=intersect(duk,dus);
    y=[muk(ia,5) muk(ia,10) muk(ia,15) 100*log(muk(ia,4)) mus(ib,4) mus(ib,14) muk(ia,16) 100*log(muk(ia,17))]; 
    if code==2; y=detrend(y,'linear'); else; y=[detrend(y(:,1:7),'constant') detrend(y(:,8),'linear')]; end;
    zindx=[1 2 3 4 5 6 7];
end;
if strcmp(ctry,'ge2')==1;
    [c,ia,ib]=intersect(dge,dus);
    y=[mge(ia,5) mge(ia,10) mge(ia,15) 100*log(mge(ia,4)) mus(ib,4) mus(ib,14) mge(ia,19) mge(ia,16) 100*log(mge(ia,17))];
    if code==2; y=detrend(y,'linear'); else; y=[detrend(y(:,1:7),'constant') detrend(y(:,8),'linear')]; end;
    zindx=[1 2 3 4 5 6 7 8];
end; 
if strcmp(ctry,'ja2')==1;
    [c,ia,ib]=intersect(dja,dus);
    y=[mja(ia,5) mja(ia,10) mja(ia,15) 100*log(mja(ia,4)) mus(ib,4) mus(ib,14) mja(ia,16) 100*log(mja(ia,17))]; 
    if code==2; y=detrend(y,'linear'); else; y=[detrend(y(:,1:7),'constant') detrend(y(:,8),'linear')]; end;
    zindx=[1 2 3 4 5 6 7];
end;
if strcmp(ctry,'none')==1; 
    c=dus;
    y=[mus(:,4) mus(:,9) mus(:,14) log(mus(:,15)) 100*log(mus(:,18)) mus(:,19)];
    if code==2; y=detrend(y,'linear'); else; y=[detrend(y(:,1:4),'constant') detrend(y(:,5),'linear') detrend(y(:,6),'constant')]; end;
    zindx=[shock 4 5 6]; 
end;

p=bicpic(y);   
[bigt,n]=size(y);
[d,ic,id]=intersect(c,datenum(z0(:,1),z0(:,2),eomday(z0(:,1),z0(:,2))));
z=zeros(bigt,size(z0,2));
z(ic,:)=z0(id,:);
z=z(:,3:end);
w=y(p+1:bigt,:); 
q=y(p:bigt-1,:);
for j=2:p; q=[q y(p+1-j:bigt-j,:)]; end;
[bhat,sigma,capy,capx,res] = varest_bayes(y,p);
capw=z(p+1:end,zindx(2:end));
sigmaaug=[res capw]'*[res capw]/bigt;
zindx=zindx(1);
rand('seed',123); randn('seed',123);
nboot=5000;
burnin=1000;
jk=1;
nw=size(capw,2);
while jk<=nboot+burnin;  %Begin the posterior simulation
    c=chol(inv(sigmaaug*bigt))'*randn(n+nw,bigt);
    sigmaprop=inv(c*c');
    vcov=kron(sigmaprop(1:n,1:n),inv(capx'*capx));
    bhatprop=bhat+(reshape(chol(vcov)'*randn(p*n*n,1),p*n,n)');
    bhatb=bhatprop; sigmab=sigmaprop;     
    Ub=z(p+1:end,zindx);
    if jk==1; bhatb=bhatprop; sigmab=sigmaprop; end;
    if jk>1; 
        aprob=exp(postprob(bhatprop,sigmaprop,thetab,psib,w,q,capw,Ub)-postprob(bhatb,sigmab,thetab,psib,w,q,capw,Ub));
        aprob=aprob*niw(bhatb,sigmab,w,q,capw)/niw(bhatprop,sigmaprop,w,q,capw);
        aprob=min(aprob,1);
        if rand(1,1)<aprob; bhatb=bhatprop; sigmab=sigmaprop; end;
    end;
    if jk==1;
        Ub=[Ub res];
        capwtilde=[capw Ub(:,2:end)];
        thetab=(capwtilde'*Ub(:,1))/bigt;
        thetab=[thetab(1:nw);thetab(nw+nw+1:end)];
        psib=(Ub(:,1)'*Ub(:,1))/bigt;
        psitildeb=sqrt(abs(psib-([thetab' thetab(1:nw)']*sigmaaug*[thetab;thetab(1:nw)])));
    else;
        resb=w-(q*bhatb');
        Ub=[Ub resb];
        capwtilde=[Ub(:,2:end) capw];
        thetaprop=thetab+(1e-5*randn(n,1));
        psitildeprop=abs(psitildeb+(1e-5*randn(1,1)));
        sigma21b=[thetab' thetab(1:nw)'];
        sigma21prop=[thetaprop' thetaprop(1:nw)'];
        e0=(Ub(:,1)-(capwtilde*inv(sigmab)*sigma21b'))/psitildeb;
        e1=(Ub(:,1)-(capwtilde*inv(sigmab)*sigma21prop'))/psitildeprop;
        aprob=min(prod(normpdf(e1,0,1))/prod(normpdf(e0,0,1)),1);
        if rand(1,1)<aprob; thetab=thetaprop; psitildeb=psitildeprop; end;
    end;
    alphab=-0.25*thetab/thetab(normind);  %Normalize shocks to be 25 basis point easing
    if strcmp(ctry,'none')==1;
        Ab=[bhatb;[eye(n*(p-1)) zeros(n*(p-1),n)]];
        for t=1:40; %impulse responses out to 40 quarters
            imp0=(Ab^(3*(t-1)))*[alphab;zeros(n*(p-1),1)];
            impb(:,t,jk)=imp0(1:n);
        end;
        %impb gives all the VAR impulse repsonses; now calculate impulse responses of term premia etc.
        tpb(1,jk)=impb(2,1,jk)-mean(impb(1,1:20,jk));
        tpb(2,jk)=impb(3,1,jk)-mean(impb(1,1:40,jk));
        jk=jk+1;
    end;
    if strcmp(ctry,'ge2')+strcmp(ctry,'ja2')+strcmp(ctry,'uk2')==1;
        Ab=[bhatb;[eye(n*(p-1)) zeros(n*(p-1),n)]];
        for t=1:40;
            imp0=(Ab^(3*(t-1)))*[alphab;zeros(n*(p-1),1)];
            impb(:,t,jk)=imp0(1:n);
        end;       
        for t=1:39;
            uipdb(t,jk)=impb(5,t,jk)-impb(1,t,jk)-(4*(impb(4,t+1,jk)-impb(4,t,jk)));
            carryb(t,jk)=impb(5,t,jk)-impb(1,t,jk);
        end;
        uipdb(:,jk)=cumsum(uipdb(:,jk))./[1:1:39]';
        carryb(:,jk)=cumsum(carryb(:,jk))./[1:1:39]';
        tpb(1,jk)=impb(2,1,jk)-mean(impb(1,1:20,jk));
        tpb(2,jk)=impb(3,1,jk)-mean(impb(1,1:40,jk));
        jk=jk+1;
    end;
    if strcmp(ctry,'ge')+strcmp(ctry,'ja')+strcmp(ctry,'uk')==1; 
        Ab=[bhatb;[eye(n*(p-1)) zeros(n*(p-1),n)]];
        for t=1:40;
            imp0=(Ab^(3*(t-1)))*[alphab;zeros(n*(p-1),1)];
            impb(:,t,jk)=imp0(1:n);
        end;       
        for t=1:79;
            imp0=(Ab^(3*(t-1)))*[alphab;zeros(n*(p-1),1)];
            impext(:,t)=imp0(1:n);
        end;
        for t=1:39;
            uipdb(t,jk)=impb(5,t,jk)-impb(1,t,jk)+(4*(impb(4,t+1,jk)-impb(4,t,jk)));
	    carryb(t,jk)=impb(5,t,jk)-impb(1,t,jk);
        end;
        uipdb(:,jk)=cumsum(uipdb(:,jk))./[1:1:39]';
        carryb(:,jk)=cumsum(carryb(:,jk))./[1:1:39]';
        for t=1:40;
            tpfb(t,jk)=impext(6,t)-mean(impext(5,t:t+39));
        end;
        jk=jk+1;
       end;
end;
impb=impb(:,:,burnin+1:end); 
if exist('uipdb')==1; uipdb=uipdb(:,burnin+1:end); end;
if exist('carryb')==1; carryb=carryb(:,burnin+1:end); end;
if exist('tpfb')==1; tpfb=tpfb(:,burnin+1:end); end;
if exist('tpb')==1; tpb=tpb(:,burnin+1:end); end;


imp=median(impb,3);
if strcmp(ctry,'none')~=1; uipd=median(uipdb,2); carry=median(carryb,2); end;
if strcmp(ctry,'none')+strcmp(ctry,'ge2')+strcmp(ctry,'ja2')+strcmp(ctry,'uk2')==1; tp=median(tpb,2); end;
if strcmp(ctry,'ge')+strcmp(ctry,'ja')+strcmp(ctry,'uk')==1; tpf=median(tpfb,2); end;

    
bci=[round(0.16*nboot);round(0.84*nboot)];  %Lower and upper percentiles of Bootstrap CIs
cv='k';
impb=sort(impb,3); 

if strcmp(ctry,'none')==1;
    tpb=sort(tpb,2);
    disp('US Term Premium Effects (5 year/10 year)');
    disp(0.1*round(1000*[tp tpb(:,bci(1)) tpb(:,bci(2))]));
end;


if strcmp(ctry,'ge')+strcmp(ctry,'ja')+strcmp(ctry,'uk')==1;
    uipdb=sort(uipdb,2); 
    carryb=sort(carryb,2);
    tpfb=sort(tpfb,2);
    disp('Foreign Term Premium Effects (10 year)');
    disp(0.1*round(1000*[tpf(1) squeeze(tpfb(1,bci))]));
    figure(1);  %Effects on the exchange rate
    if strcmp(ctry,'uk')==1; subplot(3,3,shock); end;
    if strcmp(ctry,'ge')==1; subplot(3,3,shock+3); end;
    if strcmp(ctry,'ja')==1; subplot(3,3,shock+6); end;
    plot(horr,squeeze(impb(4,1:nlead+1,[bci(1) bci(2)])),'Linewidth',2,'Color',cv,'Linestyle','--');
    hold on;
    plot(horr,squeeze(imp(4,1:nlead+1)),'Linewidth',2,'Color',cv);
    xlim([0 60]);
    if strcmp(ctry,'uk')==1; title({char(shockvec(shock));'Pound'}); end; 
    if strcmp(ctry,'ge')==1; title('Euro'); end;
    if strcmp(ctry,'ja')==1; title('Yen'); end;
    xlim([1 3*nlead]);
    figure(2);  %Effects on foreign 3 month interest rates
    if strcmp(ctry,'uk')==1; subplot(3,3,shock); end;
    if strcmp(ctry,'ge')==1; subplot(3,3,shock+3); end;
    if strcmp(ctry,'ja')==1; subplot(3,3,shock+6); end;
    plot(horr,squeeze(impb(5,1:nlead+1,[bci(1) bci(2)])),'Linewidth',2,'Color',cv,'Linestyle','--');
    hold on;
    plot(horr,squeeze(imp(5,1:nlead+1)),'Linewidth',2,'Color',cv);
    xlim([0 60]);
    if strcmp(ctry,'uk')==1; title({char(shockvec(shock));'UK'}); end; 
    if strcmp(ctry,'ge')==1; title('Germany'); end;
    if strcmp(ctry,'ja')==1; title('Japan'); end;
    xlim([1 3*nlead]);
    figure(3);  %Effects on foreign 10 year interest rates
    if strcmp(ctry,'uk')==1; subplot(3,3,shock); end;
    if strcmp(ctry,'ge')==1; subplot(3,3,shock+3); end;
    if strcmp(ctry,'ja')==1; subplot(3,3,shock+6); end;
    plot(horr,squeeze(impb(6,1:nlead+1,[bci(1) bci(2)])),'Linewidth',2,'Color',cv,'Linestyle','--');
    hold on;
    plot(horr,squeeze(imp(6,1:nlead+1)),'Linewidth',2,'Color',cv);
    if code==0; %Include foreign term premium breakout
        plot(horr,squeeze(tpf(1:nlead+1)),'Linewidth',1,'Color','r','Linestyle','-.');
    end;
    xlim([0 60]);
    if strcmp(ctry,'uk')==1; title({char(shockvec(shock));'UK'}); end; 
    if strcmp(ctry,'ge')==1; title('Germany'); end;
    if strcmp(ctry,'ja')==1; title('Japan'); end;
    xlim([1 3*nlead]);
    figure(4);   %Effects on the foreign exchange risk premium
    if strcmp(ctry,'uk')==1; subplot(3,3,shock); end;
    if strcmp(ctry,'ge')==1; subplot(3,3,shock+3); end;
    if strcmp(ctry,'ja')==1; subplot(3,3,shock+6); end;
    plot(horr,squeeze(uipdb(1:nlead+1,[bci(1) bci(2)])),'Linewidth',2,'Color',cv,'Linestyle','--');
    hold on;
    plot(horr,uipd(1:nlead+1),'Linewidth',2,'Color',cv);
    if code==0; %Include carry breakout
        plot(horr,squeeze(carry(1:nlead+1)),'Linewidth',1,'Color','r','Linestyle','-.');
    end;
    xlim([0 60]);
    if strcmp(ctry,'uk')==1; title({char(shockvec(shock));'Pound'}); end;
    if strcmp(ctry,'ge')==1; title('Euro'); end;
    if strcmp(ctry,'ja')==1; title('Yen'); end;
    xlim([1 3*nlead]);
end;

if strcmp(ctry,'none')==1;
    figure(5);
    subplot(3,3,shock);
    plot(horr,squeeze(impb(4,1:nlead+1,[bci(1) bci(2)])),'Linewidth',2,'Color',cv,'Linestyle','--');
    hold on;
    plot(horr,squeeze(imp(4,1:nlead+1)),'Linewidth',2,'Color',cv);
    xlim([0 60]);
    title({char(shockvec(shock));'Unemployment'});
    subplot(3,3,shock+3);
    plot(horr,squeeze(impb(5,1:nlead+1,[bci(1) bci(2)])),'Linewidth',2,'Color',cv,'Linestyle','--');
    hold on;
    plot(horr,squeeze(imp(5,1:nlead+1)),'Linewidth',2,'Color',cv);
    xlim([0 60]);
    title('Prices');
    subplot(3,3,shock+6);
    plot(horr,squeeze(impb(6,1:nlead+1,[bci(1) bci(2)])),'Linewidth',2,'Color',cv,'Linestyle','--');
    hold on;
    plot(horr,squeeze(imp(6,1:nlead+1)),'Linewidth',2,'Color',cv);
    xlim([0 60]);
    title('EBP');
end;

if strcmp(ctry,'ge2')+strcmp(ctry,'ja2')+strcmp(ctry,'uk2')==1;
    uipdb=sort(uipdb,2); 
    carryb=sort(carryb,2);
    tpb=sort(tpb,2);
    figure(1);   %Effects on the exchange rate
    if strcmp(ctry,'uk2')==1; subplot(2,2,1); end;
    if strcmp(ctry,'ge2')==1; subplot(2,2,2); end;
    if strcmp(ctry,'ja2')==1; subplot(2,2,3); end;
    plot(horr,squeeze(impb(4,1:nlead+1,[bci(1) bci(2)])),'Linewidth',2,'Color',cv,'Linestyle','--');
    hold on;
    plot(horr,squeeze(imp(4,1:nlead+1)),'Linewidth',2,'Color',cv);
    if strcmp(ctry,'uk2')==1; title('Pound'); end;
    if strcmp(ctry,'ge2')==1; title('Euro'); end;
    if strcmp(ctry,'ja2')==1; title('Yen'); end;
    xlim([1 3*nlead]);
    figure(2);  %Effects on US interest rates
    if strcmp(ctry,'uk2')==1; subplot(3,2,1); end;
    if strcmp(ctry,'ge2')==1; subplot(3,2,3); end;
    if strcmp(ctry,'ja2')==1; subplot(3,2,5); end;
    plot(horr,squeeze(impb(5,1:nlead+1,[bci(1) bci(2)])),'Linewidth',2,'Color',cv,'Linestyle','--');
    hold on;
    plot(horr,squeeze(imp(5,1:nlead+1)),'Linewidth',2,'Color',cv);
    xlim([1 3*nlead]);
    if strcmp(ctry,'uk2')==1; title('UK Shock: 3-month US rates'); end;
    if strcmp(ctry,'ge2')==1; title('Euro Shock: 3-month US rates'); end;
    if strcmp(ctry,'ja2')==1; title('Japan Shock: 3-month US rates'); end;
    if strcmp(ctry,'uk2')==1; subplot(3,2,2); end;
    if strcmp(ctry,'ge2')==1; subplot(3,2,4); end;
    if strcmp(ctry,'ja2')==1; subplot(3,2,6); end;
    plot(horr,squeeze(impb(6,1:nlead+1,[bci(1) bci(2)])),'Linewidth',2,'Color',cv,'Linestyle','--');
    hold on;
    plot(horr,squeeze(imp(6,1:nlead+1)),'Linewidth',2,'Color',cv);
    if strcmp(ctry,'uk2')==1; title('UK Shock: 10-year US rates'); end;
    if strcmp(ctry,'ge2')==1; title('Euro Shock: 10-year US rates'); end;
    if strcmp(ctry,'ja2')==1; title('Japan Shock: 10-year US rates'); end;
    xlim([1 3*nlead]);
    figure(3); %Effects on the foreign exchange risk premium
    if strcmp(ctry,'uk2')==1; subplot(2,2,1); end;
    if strcmp(ctry,'ge2')==1; subplot(2,2,2); end;
    if strcmp(ctry,'ja2')==1; subplot(2,2,3); end;
    plot(horr,squeeze(uipdb(1:nlead+1,[bci(1) bci(2)])),'Linewidth',2,'Color',cv,'Linestyle','--');
    hold on;
    plot(horr,uipd(1:nlead+1),'Linewidth',2,'Color',cv);
    if strcmp(ctry,'uk2')==1; title('Pound'); end;
    if strcmp(ctry,'ge2')==1; title('Euro'); end;
    if strcmp(ctry,'ja2')==1; title('Yen'); end;
    xlim([1 3*nlead]);
end;


   